diff --git a/pimd/pim_hello.c b/pimd/pim_hello.c
index 833103c27fc3..f6f5c02925b9 100644
--- a/pimd/pim_hello.c
+++ b/pimd/pim_hello.c
@@ -452,19 +452,19 @@ int pim_hello_build_tlv(struct interface *ifp, uint8_t *tlv_buf,
 
 	/* Secondary Address List */
 	if (ifp->connected->count) {
-		curr = pim_tlv_append_addrlist_ucast(curr, pastend,
-						     ifp->connected, AF_INET);
+		curr = pim_tlv_append_addrlist_ucast(curr, pastend, ifp, PIM_AF);
 		if (!curr) {
 			if (PIM_DEBUG_PIM_HELLO) {
 				zlog_debug(
-					"%s: could not set PIM hello v4 Secondary Address List option for interface %s",
-					__func__, ifp->name);
+					"%s: could not set PIM hello %s Secondary Address List option for interface %s",
+					__func__, PIM_AF_NAME, ifp->name);
 			}
 			return -4;
 		}
+#if PIM_IPV == 4
 		if (pim->send_v6_secondary) {
 			curr = pim_tlv_append_addrlist_ucast(
-				curr, pastend, ifp->connected, AF_INET6);
+				curr, pastend, ifp, AF_INET6);
 			if (!curr) {
 				if (PIM_DEBUG_PIM_HELLO) {
 					zlog_debug(
@@ -474,6 +474,7 @@ int pim_hello_build_tlv(struct interface *ifp, uint8_t *tlv_buf,
 				return -4;
 			}
 		}
+#endif
 	}
 
 	return curr - tlv_buf;
diff --git a/pimd/pim_tlv.c b/pimd/pim_tlv.c
index 65975ce14640..9349d2f1b297 100644
--- a/pimd/pim_tlv.c
+++ b/pimd/pim_tlv.c
@@ -29,6 +29,10 @@
 #include "pim_tlv.h"
 #include "pim_str.h"
 #include "pim_msg.h"
+#if PIM_IPV == 6
+#include "pim_iface.h"
+#include "pim_addr.h"
+#endif
 
 #if PIM_IPV == 4
 #define PIM_MSG_ADDRESS_FAMILY PIM_MSG_ADDRESS_FAMILY_IPV4
@@ -226,12 +230,17 @@ int pim_encode_addr_group(uint8_t *buf, afi_t afi, int bidir, int scope,
 }
 
 uint8_t *pim_tlv_append_addrlist_ucast(uint8_t *buf, const uint8_t *buf_pastend,
-				       struct list *ifconnected, int family)
+				       struct interface *ifp, int family)
 {
 	struct listnode *node;
 	uint16_t option_len = 0;
 	uint8_t *curr;
 	size_t uel;
+	struct list *ifconnected = ifp->connected;
+#if PIM_IPV == 6
+	struct pim_interface *pim_ifp = ifp->info;
+	pim_addr addr;
+#endif
 
 	node = listhead(ifconnected);
 
@@ -252,8 +261,16 @@ uint8_t *pim_tlv_append_addrlist_ucast(uint8_t *buf, const uint8_t *buf_pastend,
 		struct prefix *p = ifc->address;
 		int l_encode;
 
+#if PIM_IPV == 4
 		if (!CHECK_FLAG(ifc->flags, ZEBRA_IFA_SECONDARY))
 			continue;
+#else
+		addr = pim_addr_from_prefix(p);
+		if (!pim_addr_cmp(pim_ifp->primary_address, addr))
+			/* don't add the primary address
+			 * into the secondary address list */
+			continue;
+#endif
 
 		if ((curr + uel) > buf_pastend)
 			return 0;
diff --git a/pimd/pim_tlv.h b/pimd/pim_tlv.h
index 64b3a0b6ba72..63bd2c41f69f 100644
--- a/pimd/pim_tlv.h
+++ b/pimd/pim_tlv.h
@@ -82,7 +82,7 @@ uint8_t *pim_tlv_append_2uint16(uint8_t *buf, const uint8_t *buf_pastend,
 uint8_t *pim_tlv_append_uint32(uint8_t *buf, const uint8_t *buf_pastend,
 			       uint16_t option_type, uint32_t option_value);
 uint8_t *pim_tlv_append_addrlist_ucast(uint8_t *buf, const uint8_t *buf_pastend,
-				       struct list *ifconnected, int family);
+				       struct interface *ifp, int family);
 
 int pim_tlv_parse_holdtime(const char *ifname, pim_addr src_addr,
 			   pim_hello_options *hello_options,
